;;;
;;;
;;;
;;;MACROCAD 1994,1995 TETRALOGIC
;;;
;;;FREEWARE - ENJOY 
;;;Hopefully something here will prove useful. Not all the functions that are
;;;in this file are described when you type "macrocad" at the prompt so look
;;;through it.
;;;
;;;just simple tools that I use every day, and thought you might like 'em too
;;;
;;; Christopher Barry
;;; I can be reached @ CIS 73404,210
;;;  Send me your cool tools or whatever. 
;;;                                      Happy CADDing
;;
;
(princ "\nInitializing...")
(defun c:zd () (command "zoom" "dynamic"))
(defun c:ze () (command "zoom" "extents"))
(defun c:zz () (command "zoom" "previous"))
(defun c:zw () (command "zoom" "window"))
;; ===========================================================================
;;
;; STRSTRIP - used in C:XOUT
;;
;;
;; takes full file pathname and returns cleaned up name without extension
;; or leading spaces.
(defun strstrip
  (f_name / fn cnt flag tmp)
  ;;
  ;; strip the extension and then the the rest of the path except
  ;; for the last 9 characters.
  ;; set the counter to 9.
  ;; set the loop flag to true.
  ;;
  (setq
    fn (substr f_name 1 (- (strlen f_name) 4))
    fn (substr fn (- (strlen fn) 9))
    cnt 9
    flag T
  )
  ;;
  ;; starting at the last char, see if it's a backslash (it should'nt be).
  ;; back up the string until a backslash is encountered.
  ;; strip it and return the rest of the string.
  ;;
  (while flag
    (setq tmp (substr fn cnt 1))
    (if (eq (ascii tmp) 92)
      (progn
        (setq fn (substr fn (+ cnt 1)))
        (setq flag nil)
      )
      (setq cnt (- cnt 1))
    )
  )
  fn
)
;; ===========================================================================
;; ===========================================================================
(defun c:20xp ()
  (command ".zoom" "1/20xp");zoom mspace vport to 20 scale in pspace
)
(defun c:z9 ()
  (command ".zoom" ".9x");zoom out a tad
)
(defun c:xd ()
  (princ "\nDetaching all Cross References...");remove all xrefs
  (command ".xref" "detach" "*")
  (command "redraw")
  (princ)
)
(defun c:xin ( / fn)
  (command ".undo" "group")       ;bring in xref @ 0,0,0  0-rotation
  (command "dragmode" "off")
  (setq fn (getfiled "Select XREF to Attach @ 0,0" "" "dwg" 2))
  (cond ( (= nil fn)  (setvar "dragmode" 2)(exit)))
  (princ (strcat "\nAttaching " fn "..."))
  (princ "\nRegenerating Drawing...")
  (command "xref" "attach" fn "0,0" "" "" "")
  (command "dragmode" "auto")
  (command ".undo" "end")
  (princ)
)
(defun c:xout ()
  (defun *error* (s)    ;remove xref by picking or dialog selection
    (princ "\nFunction Aborted.")
    (setq
      *error* olderr
      fn nil
      ans nil
    )
    (princ)
  )
  (initget 128 "eXit Look Pick")
  (setq ans (getkword "\nXRef Detach-Selection type: eXit/Look/<Pick>: "))
  (defun look ( / x1)
    (setq fn nil)
    (c:x?)
    (setq x1 (getstring "\nPress Return to continue..."))
    (setq fn (getfiled "Select XREF to Detach" "" "dwg" 2))
    (if (not fn)
      (*error*)
    )
    (setq fn
      (strstrip fn)
    )
  )
  (defun pick_it ()
    (setq olderr *error*)
    (setq fn
      (entsel "\nPick Xref to Detach...")
    )
    (if (= fn nil)
      (progn
        (princ "\nNothing selected!")
        (princ "\n")
        (setq ans nil)
        (c:xout)
      )
      (setq fn
        (cdr
          (assoc 2
            (entget
              (car fn
              )
            )
          )
        )
      )
    )
    fn
  )
  (cond
    ((= ans "Look") (look)
    )
    ((or (= ans nil)(= ans "Pick")) (pick_it)
    )
    (T (*error*))
  )
  (princ (strcat "\nDetaching " fn "..."))
  (command "xref" "detach" fn)
  (command "redraw")
  (setq
    *error* olderr
    fn nil
    ans nil
  )
  (princ)
)
(defun c:x? () (command "xref" "?" "*");see xrefs in dwg
  (princ)
)
(defun c:zq ();zoom center 10x w/single pick
  (prompt "\nPlace X-Hairs on target and pick to zoom in\n")
  (command "zoom" "c" pause "10x")
  (princ)
)
(defun c:v () (command "view" "r" "oa")
(princ));restore view named oa
(defun c:vv () (command "view" "s" "oa")
(princ));make view named oa from current view
(defun c:qx () ;extend macro
  (prompt "\n QX.LSP - quick extend macro......\n")
  (prompt "\n place X-hairs on target...pick to zoom-in")
  (command ".zoom" "c" pause "2x")
  (prompt "\n draw boundry line\n")
  (command ".line" pause pause "")
  (prompt "\n select line to extend")
  (command ".extend" "l" "" pause "")
  (command ".erase" "l" "")
  (command ".zoom" "p")
  (princ)
)
(defun c:tl ();trim macro
  (prompt "\nDraw TRIM-TO Boundry Line (Pick 2 points)")
  (command ".line" pause pause "")
  (prompt "\nPick line segment to trim")
  (command ".trim" "l" "" pause "")
  (command ".erase" "p" "")
  (princ)
)
;;****************************** modemacro **********************************
;;
;;I find this both cool looking and helpful. If your graphics card will do it,
;;try setting the status line to 2 lines. That way you can see the menu 
;;selections and the modemacro bar. If your using the ATI Graphics Ultra Pro
;;type ADICFG in AutoCAD and you can set it up there. 
;;To toggle between status bars type "1", "2" or "3" @ the Command: prompt.
;;later...<g>
;;
(defun c:mode1 ()
  (if (and (eq (getvar "ucsname") "")(= (getvar "worlducs") 1))
    (setvar "users1" "World")
    (if (eq (getvar "ucsname") "")
      (setvar "users1" "Unnamed")
      (setvar "users1" (getvar "ucsname"))
    )
  ) 
  (setvar "modemacro"
    (strcat
      " L:$(substr,$(getvar,clayer),1,16)  "
      "OS:$(getvar,osmode)   "
      "TI:$(getvar,tilemode)  "
      "TEXT:$(getvar,textstyle)"
      " @:$(getvar,textsize)  "
      "DM:$(getvar,dragmode)  "
      "UCS:$(getvar,users1)  "      
      "MODULE:$(getvar,menuname)  "
      "DWG:$(substr,$(getvar,dwgname),$(strlen,$(getvar,dwgprefix)),8)"
    )
  )
  (princ)
)
(defun c:mode2 ()
  (setvar "modemacro"
    (strcat
      "L:$(substr,$(getvar,clayer),1,16) "
      "DWG:$(getvar,dwgname)"
    )
  )
  (princ)
)
(defun c:1 ()
  (c:mode1)
)
(defun c:mode2 ()
  (if (and (eq (getvar "ucsname") "")(= (getvar "worlducs") 1))
    (setvar "users1" "World")
    (if (eq (getvar "ucsname") "")
      (setvar "users1" "Unnamed")
      (setvar "users1" (getvar "ucsname"))
    )
  ) 
  (setvar "modemacro"
    (strcat
      " CMD:$(getvar,cmdnames)  "
      "APERTURE:$(getvar,aperture)  "
      "PICKBOX:$(getvar,pickbox)  "
      "CVPORT:$(getvar,cvport)  "
      "DRAGP1:$(getvar,dragp1)  "
      "DRAGP2:$(getvar,dragp2)  "
      "MAXSORT:$(getvar,maxsort)  "      
      "PD:$(getvar,pdmode)  "
      "PDS:$(getvar,pdsize)  "
    )
  )
  (princ)
)
(defun c:mode ()
  (setvar "modemacro"
    (strcat
      "L:$(substr,$(getvar,clayer),1)  "
      " DWG:$(getvar,dwgname)"
    )
  )
  (princ)
)
(defun c:1 ();sets informative status bar
  (c:mode1)
)
(defun c:2 ();sets other info in status bar
  (c:mode2)
)
(defun c:3 ();layer name and full path of drawing
  (c:mode)
)
;;***************************** end ModeMacro *******************************
(defun c:ci ();cuts line @ int (hopefully!)if it doesent, erase then undo
  ;the line you want to break. I know, marginal at best.
  ;;set up
  (setq old_ap (getvar "aperture"))
  (setq old_box (getvar "pickbox"))
  (setvar "pickbox" 4)
  (setvar "aperture" 6)
  ;;main
  (prompt "\nSelect Intersection to cut line at...")
  (command "_.break" "int" pause "first" "@" "@" )
  ;;reset
  (setvar "aperture" old_ap)
  (setvar "pickbox" old_box)
  (princ)
)
(defun c:ct ( / oldclr oldcmd en cir );uses a circle to trim a chunk out of
  ;the middle of a line or multiple lines
  (defun *error* (s) 
    (princ "\nFunction Aborted.")
    (setq
      *error* olderr
    )
    (setvar "cmdecho" oldcmd)
    (command ".color" oldclr)
    (command ".erase" cir "")
    (redraw)
    (princ)
  )
  (graphscr)
  (command ".undo" "group")
  (setq oldclr (getvar "cecolor")
    oldcmd (getvar "cmdecho")
  )
  (setvar "cmdecho" 0)
  (setvar "cecolor" "50")
  (princ 
  "\nPick a point for Trim Circle center, then stretch diameter and pick again...")
  (command ".circle" pause pause)
  (setq cir (entlast))
  (setq en (entsel "\nSingle pick entitiy to trim..."))
  (princ "\n ")
  (while en
    (command ".trim" cir "" en "")
    (setq en (entsel "Next entity... "))
  )
  (command ".erase" cir "")
  (redraw)
  (setvar "cecolor" oldclr)
  (command ".undo" "end")
  (princ)
)
(command "_.undefine" "end")
(command "_.undefine" "save")
(defun c:zsave ()
  (command "_.layer" "f" "*dca*" "")
  (command "_.zoom" "e")
  (command "_.zoom" "a")
  (command "_.zoom" ".9x")
  (command "_.save" "")
  (command "_.mslide" "")
  (princ)
)
(defun c:ssave ()
  (command "_.save" "")
  (command "_.mslide" "")
  (princ)
)
(defun c:save ()
  (command "_.save" "")
)
(defun c:done ()
  (princ (strcat "\nSaving: " (getvar "dwgname")))
  (command "_.save" "")
  (princ "\nEnding AutoCAD")
  (command "_.quit")
)
(defun c:xdone ()
  (princ "\nDetaching all Xrefs...")
  (command "_.xref" "d" "*")
  (princ (strcat "\nSaving: " (getvar "dwgname")))
  (command "_.save" "")
  (princ "\nEnding AutoCAD")
  (command "_.quit")
)
(defun c:next ()
  (princ "\nDetaching all Xrefs...")
  (command "_.xref" "d" "*")
  (princ (strcat "\nSaving: " (getvar "dwgname")))
  (command "_.save" "")
  (command "~" (command "_.open"))
)
(defun c:ld ()
  (command "dim")
  (command "lea")
)
(defun c:lac ()
  (load "acad")
)
(defun c:lda ()
  (load "loadall")
)
(defun c:macrocad ()
  (textscr)
  (princ "\n   ******************************* MACROCAD ****************************")
  (princ "\n   COMMAND NAME                                         ACTION")
  (princ "\n   *********************************************************************")
  (terpri)
  (princ "\n   ZE...................................................Zoom Extents")
  (princ "\n   ZD...................................................Zoom Dynamic")
  (princ "\n   ZZ...................................................Zoom Previous")
  (princ "\n   ZW...................................................Zoom Window")
  (princ "\n   ZQ.................................................Zoom Center 10X")
  (terpri)
  (princ "\n   QX...................................................Quick Extend")
  (princ "\n      Allows quick extension of line by first zooming in close,")
  (princ "\n      draws \"extend to\" line, then lets you pick the line to")
  (princ "\n      extend. Finishes up by zooming back out and erasing the")
  (princ "\n      \"extend to\" line.")
  (terpri) 
  (princ "\n   TL...................................................Trim Line")
  (princ "\n      Allows quick trimming of line \(single pick\) after you")
  (princ "\n      draw the trim line, which is erased after trim.")                
  (terpri)
  (princ "\n   CT...................................................Circle Trim")
  (princ "\n      Draws circle as the trim line and allows multiple picks.")
  (terpri)
  (setq x1 (getstring "\nMore...")
  x1 nil)
  (princ)
  (princ "\n   CI...................................................Cut Intersection")
  (princ "\n      Allows single pick break of lines/plines @ intersections.")
  (terpri)
  (princ "\n   XIN...........................Streamlined XREF Attatch @ 0,0 & 0 rot.")
  (terpri)
  (princ "\n   XOUT...................................Powerful XREF Detach macro")
  (terpri)
  (princ "\n   X?...........................................Current XREFS in DWG")
  (terpri)
  (princ "\n   XD...............................................Detach all XREFS")
  (terpri)
  (princ "\n   V.............................Quick view restore to View named OA")
  (princ "\n      Name any view in your DWG \"OA\" and \"V\" will restore instantly")
  (terpri)
  (princ "\n   VV............................Quick view save to View named OA")
  (princ "\n      Saves the current display to view that V restores")
  (terpri)
  (princ "\n   1, 2 & 3....................................ModeMacro Status Bars")
  (princ "\n      Commands are 1 ,2 & 3 to select between them")

  ;(setq x1 (getstring "\nMore..."))
  (princ)
)

(c:mode1)
(princ "\ MacroCAD Loaded. 1994 (C) TetraLogic")
(princ "\nType MACROCAD for complete list of new commands")

